package cc.fascinated.bat.features.afk;

import cc.fascinated.bat.event.EventListener;
import cc.fascinated.bat.features.afk.profile.AfkProfile;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.User;
import net.dv8tion.jda.api.events.message.MessageReceivedEvent;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class AfkMentionListener implements EventListener {
    @Override
    public void onGuildMessageReceive(@NonNull BatGuild guild, @NonNull BatUser user, @NonNull MessageReceivedEvent event) {
        Message message = event.getMessage();
        List<User> mentionedUsers = message.getMentions().getUsers();
        if (mentionedUsers.isEmpty()) {
            return;
        }
        User mentionedUser = mentionedUsers.get(0);
        AfkProfile profile = guild.getProfile(AfkProfile.class);
        if (!profile.isAfk(mentionedUser.getId())) {
            return;
        }

        event.getMessage().reply("%s is currently AFK: %s".formatted(mentionedUser.getAsMention(), profile.getAfkReason(mentionedUser.getId()))).queue();
    }
}
