package cc.fascinated.bat.service;

import com.mongodb.client.MongoCollection;
import org.bson.Document;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.stereotype.Service;

/**
 * @author Fascinated (fascinated7)
 */
@Service
public class MongoService {
    public static MongoService INSTANCE;
    private final MongoTemplate mongoTemplate;

    @Autowired
    public MongoService(MongoTemplate mongo) {
        INSTANCE = this;
        this.mongoTemplate = mongo;
    }

    /**
     * Get the guilds collection
     *
     * @return The guilds collection
     */
    public MongoCollection<Document> getGuildsCollection() {
        return mongoTemplate.getCollection("guilds");
    }

    /**
     * Get the users collection
     *
     * @return The users collection
     */
    public MongoCollection<Document> getUsersCollection() {
        return mongoTemplate.getCollection("users");
    }
}
